<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006-2008 Andreas Braun                                |
 |                                                                      |
 | This program is free software. You can redistribute it               |
 | and/or modify it under the terms of the GNU General Public License   |
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.                         |
 |                                                                      |
 +----------------------------------------------------------------------+
 */

chdir('../../');

include_once('./include/auth.php');
include_once($config["base_path"] . '/plugins/reportit/lib_int/funct_validate.php');
include_once($config["base_path"] . '/plugins/reportit/lib_int/funct_online.php');
include_once($config["base_path"] . '/plugins/reportit/lib_int/funct_shared.php');
include_once($config["base_path"] . '/plugins/reportit/lib_int/funct_html.php');
include_once($config["base_path"] . '/plugins/reportit/lib_int/const_templates.php');

/* ============== Validation ============== */
	safeguard_xss('', '<template_title>');
/* ======================================== */

if (!isset($_REQUEST['action'])) {
	$_REQUEST['action'] = '';
}

switch ($_REQUEST['action']) {
	case 'actions':
		form_actions();
		break;
	case 'template_edit':
		include_once($config["include_path"] . "/top_header.php");
		template_edit();
		include_once($config["include_path"] . "/bottom_footer.php");
		break;
	case 'template_add':
		include_once($config["include_path"] . "/top_header.php");
		template_wizard();
		include_once($config["include_path"] . "/bottom_footer.php");
		break;
	case 'save':
		form_save();
		break;
	default:
		include_once($config["include_path"] . "/top_header.php");
		standard();
		include_once($config["include_path"] . "/bottom_footer.php");
		break;
}


function template_wizard() {
	global $colors, $config, $list_of_data_templates;

	//Clean up $_SESSION
	if(isset($_SESSION['reportit_tWizard'])) unset($_SESSION['reportit_tWizard']);

	html_wizard_header('New Template', 'cc_templates.php');

	if(sizeof($list_of_data_templates) == 0) {
		print "<tr><td bgcolor='#" . $colors['form_alternate1'] . "'><span class='textError'>There are no data templates in use.</span></td></tr>\n";
		$save_html = '';
	}else {
		$save_html = "<input type='image' src='" . $config['url_path'] . "plugins/reportit/images/button_next.gif' alt='Next' align='absmiddle'>";

		print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors['form_alternate1'] . "'>
			<br>
			<p>Choose a data template this report template should depends on.<br>
			</p>
			<b>Used data templates on this machine:</b><br>";
		form_dropdown('data_template', $list_of_data_templates, '', '', '', '', '');
		print "	    </td>
		</tr>\n";
	}

	html_wizard_footer('template_edit', 'cc_templates.php', $save_html);
}



function standard() {

	global 	$colors, $template_actions, $link_array,
			$consolidation_functions, $list_of_data_templates;

	$link  = '';

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_request("page"));
	/* ==================================================== */

	/* clean up sort_column */
	if (isset($_REQUEST["sort"])) {
		$_REQUEST["sort"] = sanitize_search_string(get_request_var("sort"));
	}

	/* clean up sort_direction string */
	if (isset($_REQUEST["mode"])) {
		$_REQUEST["mode"] = sanitize_search_string(get_request_var("mode"));
	}

	/* if the user pushed the 'clear' button */
	if (isset($_REQUEST["clear_x"])) {
		kill_session_var("sess_reportit_ts_current_page");
		kill_session_var("sess_reportit_ts_sort");
		kill_session_var("sess_reportit_ts_mode");

		unset($_REQUEST["page"]);
		unset($_REQUEST["sort"]);
		unset($_REQUEST["mode"]);
	}

	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_reportit_ts_current_page", "1");
	load_current_session_value("sort", "sess_reportit_ts_sort", "id");
	load_current_session_value("mode", "sess_reportit_ts_mode", "ASC");


	$total_rows = db_fetch_cell("SELECT COUNT(reportit_templates.id) FROM reportit_templates");

	$template_list = db_fetch_assoc("SELECT * FROM reportit_templates
		ORDER BY " . $_REQUEST['sort'] . " " . $_REQUEST['mode'] .
		" LIMIT " . (read_config_option("num_rows_device")*($_REQUEST["page"]-1)) . "," . read_config_option("num_rows_device"));

	/* generate page list */
	$url_page_select = html_custom_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, read_config_option("num_rows_device"), $total_rows, "cc_templates.php?");

	$nav = "<tr bgcolor='#6CA6CD' >
		<td colspan='8'>
			<table width='100%' cellspacing='0' cellpadding='0' border='0'>
				<tr>
					<td align='left'>
						<strong>&laquo; "; if ($_REQUEST["page"] > 1) { $nav .= "<a style='color:FFFF00' href='cc_templates.php?page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
					</td>\n
					<td align='center' class='textSubHeaderDark'>
						Showing Rows " . ((read_config_option("num_rows_device")*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < read_config_option("num_rows_device")) || ($total_rows < (read_config_option("num_rows_device")*$_REQUEST["page"]))) ? $total_rows : (read_config_option("num_rows_device")*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
					</td>\n
					<td align='right'>
						<strong>"; if (($_REQUEST["page"] * read_config_option("num_rows_device")) < $total_rows) { $nav .= "<a style='color:yellow' href='cc_templates.php?page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * read_config_option("num_rows_device")) < $total_rows) { $nav .= "</a>"; } $nav .= " &raquo;</strong>
					</td>\n
				</tr>
			</table>
		</td>
		</tr>\n";

	/* start with HTML output */
	html_start_box("<strong>Report Templates </strong>[$total_rows]", REPORTIT_WIDTH, $colors["header"], "2", "center", "cc_templates.php?action=template_add");
	print $nav;

	$desc_array = array('Template Name', 'Data Template', 'CF', 'Pre-filter', 'Locked', 'Measurands', 'Variables');
	html_header_checkbox(html_sorted_with_arrows( $desc_array, $link_array, 'cc_templates.php'));

	/* check version of Cacti -> necessary to support 0.8.6k and lower versions as well*/
	$new_version = check_cacti_version(14);

	$i = 0;

	if (sizeof($template_list) > 0) {
		foreach($template_list as $template) {
			if ($new_version) form_alternate_row_color($colors["alternate"], $colors["light"], $i, $template["id"]);
			else form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;
			?>
				<td><a
					class='linkEditMain'
					href="cc_templates.php?action=template_edit&id=<?php print $template['id'];?>">
					<?php print "{$template['description']}";?> </a>
				</td>
				<td><?php if(isset($list_of_data_templates[$template['data_template_id']])) {
						print $list_of_data_templates[$template['data_template_id']];
					}else {
						echo "<b style='color: #FF0000'>Data template not available<b>";
					}?>
				</td>
				<td><?php print $consolidation_functions[$template['cf']];?></td>
				<td><?php print $template['pre_filter'];?></td>
				<td><?php html_checked_with_arrow($template['locked']);?></td>
				<td><?php
					$link = '&id=' . $template['id'];
					echo "<a class='linkEditMain' href='cc_measurands.php?$link'>";
					echo "Edit</a>";?>
				</td>
				<td><?php
					echo "<a class='linkEditMain' href='cc_variables.php?$link'>";
					echo "Edit</a>";?>
					</td>
				<td
					style="<?php print get_checkbox_style();?>"
					width="1%"
					align="right"><input
					type='checkbox'
					style='margin: 0px;'
					name='chk_<?php print $template["id"];?>'
					title="Select"></td>
				</tr>
			<?php
		}
		if ($total_rows > read_config_option("num_rows_device")) print $nav;
	}else {
		print "<tr><td><em>No templates</em></td></tr>\n";
	}

	html_end_box(true);
	draw_actions_dropdown($template_actions);
}



function form_save() {
	global $list_of_data_templates;

	$alias		= false;
	$ds_alias	= array();

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_post('id'));
	input_validate_input_number(get_request_var_post('template_data_template'));
	form_input_validate($_POST['template_description']	, 'template_description', ''			, false, 3);
	form_input_validate($_POST['template_cf']		, 'template_cf'		, '[1-4]'		, false, 3);
	form_input_validate($_POST['template_filter']	, 'template_filter'	, ''			, true, 3);
	/* ==================================================== */

	$template_data	 				= array();
	$template_data['id'] 			= $_POST['id'];
	$template_data['description']	= $_POST['template_description'];
	$template_data['pre_filter']	= $_POST['template_filter'];
	$template_data['data_template_id']	= $_POST['data_template_id'];
	$template_data['cf']			= $_POST['template_cf'];
	$template_data['locked']		= isset($_POST['template_locked']) ? 1 : 0;

	foreach($_POST as $key => $value){
		$alias = strpos($key, 'ds_alias__');
		if($alias !== false) $ds_alias[substr($key, 10)] = trim($value);
	}

	/* workaround to be compatible with Cacti 0.8.6x, because function "sql_sanitize" changed in 0.8.7.
	Normally this also has to be added to array $template_data */
	$data_template_alias = mysql_real_escape_string(serialize($ds_alias));

	//Check if the template description is used.
	$sql 	= "SELECT COUNT(*) FROM reportit_templates WHERE description='{$template_data['description']}'
		   AND id!='{$template_data['id']}'";
	$count	= db_fetch_cell($sql);
	if($count != 0) session_custom_error_message('template_description', 'Duplicate description');

	//Check if we can unlock this template.
	if($template_data['locked'] == 0) {
		if(stat_autolock_template($template_data['id'])) {
			session_custom_error_message('template_locked', 'Unable to unlock this template without defined measurands');
		}
	}

	if(is_error_message()) {
		header('Location: cc_templates.php?action=template_edit&id=' . $_POST['id']);
	}else {
		//Save data
		$id = sql_save($template_data, 'reportit_templates');

		/* workaround to be compatible with Cacti 0.8.6x, because function "sql_sanitize" changed in 0.8.7 */
		if(is_numeric($id)) {
			$sql = "UPDATE reportit_templates SET data_template_alias = '$data_template_alias' WHERE id = $id";
			db_execute($sql);
		}

		//Return to list view if it was an existing report template
		if($_POST['id']!='0') {
			raise_message(1);
			header('Location: cc_templates.php');
		}else {
			//Return to editor
			header('Location: cc_templates.php?action=template_edit&id=' . $id);
		}
	}
}


function template_edit() {

	global $colors, $consolidation_functions, $list_of_data_templates;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var('id'));
	/* ==================================================== */

	session_custom_error_display();


	if (!empty($_GET['id'])) {
		$template_data		= db_fetch_row('SELECT * FROM reportit_templates WHERE id=' . $_GET['id']);
		strip_slashes($template_data);
		$header_label 		= '[edit: ' . $template_data['description'] . ']';
	}else {
		$header_label 		= '[new]';
	}



	$id	= (isset($_GET['id']) ? $_GET['id'] : '0');
	if(isset($_POST['data_template'])) {
		if(!isset($_SESSION['reportit_tWizard']['data_template']))
		$_SESSION['reportit_tWizard']['data_template'] = $_POST['data_template'];
	}

	$data_template_id	= (isset($template_data['data_template_id']) ? $template_data['data_template_id'] : $_SESSION['reportit_tWizard']['data_template']);
	$data_template		= $list_of_data_templates[$data_template_id];

	$form_array = array(
	'id'			=> array(
	'method'		=> 'hidden_zero',
	'value'			=> $id
	),
	'data_template_id'	=> array(
	'method'		=> 'hidden_zero',
	'value'			=> $data_template_id
	),
	'template_header'	=> array(
	'friendly_name'	=> 'General',
	'method'		=> 'spacer',
	),
	'template_description'	=> array(
	'friendly_name' => 'Name',
	'method' 		=> 'textbox',
	'max_length'	=> '100',
	'description'	=> 'The name given to this report template that has<br>to be unique.',
	'value' 		=> (isset($template_data['description']) ? $template_data['description'] : '')
	),
	'template_locked'	=> array(
	'friendly_name'	=> 'Locked',
	'method'		=> 'checkbox',
	'default'		=> 'on',
	'description'	=> 'Define this template as locked, so that normal users <br>
						    can\'t use it until you have checked it\'s functionality.',
	'value'			=> (!isset($template_data['locked']) || $template_data['locked'] == true) ? 'on' : 'off'
	),
	'template_cf'	=> array(
	'friendly_name'	=> 'Consolidation function',
	'method'		=> 'drop_array',
	'default'		=> '0',
	'description'	=> 'The name of the consolidation function to define <br>
						    which CDPs should be read out.',
	'value'			=> (isset($template_data['cf']) ? $template_data['cf'] : ''),
	'array'			=> $consolidation_functions
	),
	'template_filter'	=> array(
	'friendly_name' => 'Additional Pre-filter',
	'method' 		=> 'textbox',
	'max_length'	=> '100',
	'description'	=> 'The syntax to filter the available list of data items<br>
						    by using the data source name.',
	'value' 		=> (isset($template_data['pre_filter']) ? $template_data['pre_filter'] : '')
	),
	'template_header2'	=> array(
	'friendly_name'	=> 'Data Template',
	'method'		=> 'spacer',
	),
	'template_data_template'=> array(
	'friendly_name'	=> 'Data Template',
	'method'		=> 'custom',
	'max_length'	=> '100',
	'description'	=> 'The name of the data template the data items depend on.',
	'value'			=> $data_template,
	),
	);

	/* draw input fields for data source alias */
	$form_array = array_merge($form_array, html_template_ds_alias($id, $data_template_id));

/*
	draw_edit_form(array(
						'config' => array(),
						'fields' => $html_template_ds_alias
						)
					);
*/
	if(!empty($_GET['id'])) {
		//Build "Create links"
		$links 	= array();
		$href 	= 'cc_variables.php?action=variable_edit&template_id=' . $_GET['id'];
		$text 	= 'Create a new variable';
		$links[]= array('href' =>$href, 'text' =>$text);

		$href 	= 'cc_measurands.php?action=measurand_edit&template_id=' . $_GET['id'];
		$text 	= 'Create a new measurand';
		$links[]= array('href' =>$href, 'text' =>$text);

		html_blue_link( $links);
	}


	html_start_box("<b>Template configuration</b> $header_label", REPORTIT_WIDTH, $colors["header"], "2", "center", "");
	draw_edit_form(array(
	'config' => array(),
	'fields' => $form_array
	));
	html_end_box();

	form_save_button('cc_templates.php');
}


function form_actions() {
	global $colors, $template_actions, $config;

	if (isset($_POST['selected_items'])) {
		$selected_items = unserialize(stripslashes($_POST['selected_items']));

		if ($_POST['drp_action'] == '1') { // DELETE REPORT TEMPLATE
			$template_datas = db_fetch_assoc('SELECT id FROM reportit_templates WHERE ' . array_to_sql_or($selected_items, 'id'));

			if (sizeof($template_datas) > 0) {
				foreach ($template_datas as $template_data) {
					db_execute('DELETE FROM reportit_templates WHERE id=' . $template_data['id']);
					db_execute('DELETE FROM reportit_variables WHERE template_id=' . $template_data['id']);

					$template_reports = db_fetch_assoc('SELECT id FROM reportit_reports WHERE template_id =' .$template_data['id']);

					if(is_array($template_reports)) {
						foreach($template_reports as $template_report) {
			    db_execute('DELETE FROM reportit_reports WHERE id=' . $template_report['id']);
			    db_execute('DROP TABLE IF EXISTS reportit_rrdlist_' . $template_report['id']);
			    db_execute('DROP TABLE IF EXISTS reportit_results_' . $template_report['id']);
			    db_execute('DELETE FROM reportit_measurands WHERE template_id =' . $template_report['id']);
			    db_execute('DELETE FROM reportit_variables WHERE template_id =' . $template_report['id']);
			    db_execute('DELETE FROM reportit_rvars WHERE template_id =' . $template_report['id']);
						}
					}
				}
			}
		}elseif ($_POST['drp_action'] == '2') { //DUPLICATE REPORT TEMPLATE

			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

				$template_data = db_fetch_row('SELECT * FROM reportit_templates WHERE id = ' . $selected_items[$i]);
				$template_data['id'] = 0;
				$template_data['description'] = str_replace("<template_title>", $template_data['description'], $_POST['template_addition']);
				$template_id = sql_save($template_data, 'reportit_templates');

				//Duplicate template's measurands:
				//Get all variable from original template
				$template_measurands = db_fetch_assoc('SELECT * FROM reportit_measurands WHERE template_id = ' . $selected_items[$i] . ' ORDER BY id');
				foreach($template_measurands as $measurand) {
					$measurand['id'] 		= 0;
					$measurand['template_id'] 	= $template_id;
					sql_save($measurand, 'reportit_measurands');
				}
			}
		}
		header('Location: cc_templates.php');
		exit;
	}

	//Set preconditions
	$ds_list = ''; $i = 0;

	foreach($_POST as $key => $value) {

		if(strstr($key, 'chk_')) {
			//Fetch template id
			$id = substr($key, 4);
			$template_ids[] = $id;
			// ================= input validation =================
			input_validate_input_number($id);
			// ====================================================

			//Fetch Template description
			$template_description 	= db_fetch_cell('SELECT description FROM reportit_templates WHERE id=' . $id);
			$ds_list[$template_description] = '';

			//Fetch all descriptions of reports attached to this template
			$template_reports		= db_fetch_assoc('SELECT description FROM reportit_reports WHERE template_id=' . $id);

			foreach ($template_reports as $key => $value) {
				$ds_list[$template_description][] = $template_reports[$key]['description'];
			}
		}
	}

	include_once($config["base_path"] . '/include/top_header.php');
	html_start_box("<strong>" . $template_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "2", "center", "");
	print "<form action='cc_templates.php' method='post'>\n";

	if ($_POST['drp_action'] == '1') { //DELETE REPORT TEMPLATE
		print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
			<p>Are you sure you want to delete the following report templates?<br>";
		if(is_array($ds_list)) {
			print "<br>
				    <span class='textError'>WARNING:<br>
				    Every report attached to these templates will be deleted too!
				    </span>
				    </p>";
			foreach($ds_list as $key => $value) {
				print "<p>Template : <b>$key</b><br>";

				if(is_array($ds_list[$key])) {
					foreach($ds_list[$key] as $report_name => $value) {
						print "&#160 |_Report:<i> $value</i><br>";
					}
					print "<p>";
				}
			}
		}
		print "     </td>
		</tr>\n";

	}elseif ($_POST['drp_action'] == '2') { // DUPLICATE REPORT TEMPLATE
		print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors['form_alternate1']. "'>
			<p>When you click yes, the following report templates will be duplicated. You can
			   optionally change the title for the new report templates.
			</p>";
		if(is_array($ds_list)) {
			print "Template(s):";
			foreach($ds_list as $key => $value) {
				print "<li><strong>$key</strong></li><br>";
			}
		}
		print "<p><strong>Title:</strong><br>";
		form_text_box("template_addition", "<template_title> (1)", "", "255", "30", "text");
		print "		</p>
		    </td>
		</tr>\n";
	}

	if (!is_array($ds_list)) {
		print "<tr><td bgcolor='#" . $colors['form_alternate1']. "'><span class='textError'>You must select at least one report template.</span></td></tr>\n";
		$save_html = '';
	}else {
		$save_html = "<input type='image' src='../../images/button_yes.gif' alt='Save' align='absmiddle'>";
	}

	print " <tr>
		<td align='right' bgcolor='#eaeaea'>
		    <input type='hidden' name='action' value='actions'>
		    <input type='hidden' name='selected_items' value='" . (isset($template_ids) ? serialize($template_ids) : '') . "'>
		    <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
		    <a href='cc_templates.php'><img src='../../images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
		    $save_html
		</td>
	    </tr>";

	html_end_box();
	include_once($config["base_path"] . '/include/bottom_footer.php');
}

?>